﻿using System;
using System.Net;
using System.Net.Sockets;

namespace CanEth
{
    class CanTest
    {
        byte[] encodeFloat(float val)
        {
            // Convert to byte-wise representation
            byte[] bytes = BitConverter.GetBytes(val);
            // Change endianess
            Array.Reverse(bytes);
            return bytes;
        }


        public void send()
        {
            Socket sock = new Socket(AddressFamily.InterNetwork, SocketType.Dgram, ProtocolType.Udp);
            IPEndPoint canEthEndPoint = new IPEndPoint(IPAddress.Parse("169.254.0.10"), CanEthFrame.UDP_PORT);

            CanEthFrame canEthFrame = new CanEthFrame();
            canEthFrame.Add(new CanEthMsg(0x200, encodeFloat(70.6f)));
            sock.SendTo(canEthFrame.GetBytes(), canEthEndPoint);
            Console.WriteLine("Message sent to CAN-ETH gateway:");
            Console.WriteLine(canEthFrame[0].ToString());
        }


        public void receive()
        {
            UdpClient listener = new UdpClient(CanEthFrame.UDP_PORT);
            IPEndPoint canEthEndPoint = new IPEndPoint(IPAddress.Any, CanEthFrame.UDP_PORT);

            byte[] datagram = listener.Receive(ref canEthEndPoint);
            CanEthFrame canEthFrame = new CanEthFrame(datagram);

            foreach(var msg in canEthFrame)
            {
                Console.WriteLine(msg.ToString());
            }
        }
    }
}
